//*****************************************
// 7 spectre display to 8x8-dot-matrix-LED program for ATmega328
// CPU Clock:8MHz
//   iq[Yf[^@UWlgɂj
// File Name:ad_conv.c
//
//  PC0(ADC0): spectre in
//
//  2019/02/25 New
//*****************************************
#include				<avr/io.h>

#include				"pr_mega328_7spectre.h"
#include				"ad_conv.h"

unsigned short	spectread_data[8][N_of_AD_data];
unsigned char	spectread_count;
unsigned char	ad_conv_1;									// 1:ADC1 Convert running
unsigned char	spectre_stat;								// spectre get state 0=pulse rosing, 1=a/d strat, 2=a/d get & pules falling
unsigned char	spectre_count;								// 0:out reset sig, 1:out 1'st palse, 2:out 2'nd palse ....... 7:out 7'th palse

#define		SPECTRE_RESET_ON	PORTC |= (1 << PC0)			// PC0 High
#define		SPECTRE_RESET_OFF	PORTC &= ~(1 << PC0)		// PC0 Low
#define		SPECTRE_STROBE_ON	PORTC |= (1 << PC2)			// PC2 High
#define		SPECTRE_STROBE_OFF	PORTC &= ~(1 << PC2)		// PC2 Low
;
// **********************************************************
// ************************** A/D 1 *************************
// **********************************************************

//*****************************************
// Spectre A/D 1 Initial
// @荞ݕs̏ԂŌĂ΂Ƃ
//  PC1(ADC1): spectre in (Full Volt = VCC)
//*****************************************
void	spectread_init(void)
{
	unsigned char	i;
	unsigned char	j;

	spectread_count = 0;
	for(j = 0; j < 8; j++){
		for(i = 0; i < N_of_AD_data; i++){
			spectread_data[j][i] = 0;
		}
	}

	DDRC |= ( (1 << DDC0) | (1 << DDC2) );					// Port-C Bit0,2 : Output

	PRR &= ~(1 << PRADC);																	// ADCғ
	DIDR0 |= (1 << ADC1D);																	// AiO͐ݒ PC1

	ADMUX = ( (0 << REFS1) | (1 << REFS0) | (0 << MUX3) | (0 << MUX2) | (0 << MUX1) | (1 << MUX0) );		// ubbdgp, Select ADC1
	ADCSRA = ( (1 << ADEN) | (1 << ADSC) | (1 << ADPS2) | (1 << ADPS1) | (1 << ADPS0) );	// A/D, A/DϊJn, CK/128=8MHz/128=62.5kHz(16uS) --> 208uS
	ad_conv_1 = 1;																			// 1:ADC1 Convert running

	spectre_stat = 0;								// spectre get state 0=pulse rosing, 1=pules falling, 2=a/d strat,3=a/d data get
	spectre_count = 0;								// 0:out reset sig, 1:out 1'st palse, 2:out 2'nd palse ....... 7:out 7'th palse

}
//*****************************************
// A/D 1 close
//*****************************************
void	spectread_close(void)
{
	ADCSRA = 0;																				// A/Ds
	ad_conv_1 = 0;																			// 0:ADC1 Convert Not running
}
//*****************************************
// XyNgiA/D 1j Set A/D data to Data Buffer
//  ϊIĂȂ́@Ȃ
//*****************************************
void	ad_set_spectre_data(void)
{
	if(spectre_count == 0){
		if(spectre_stat == 0){
			SPECTRE_RESET_ON;
			spectre_stat = 1;
		}else{
			SPECTRE_RESET_OFF;
			spectre_stat = 0;
			spectre_count = 1;
		}
	}else{
		if(spectre_stat == 0){
			SPECTRE_STROBE_ON;
			spectre_stat = 1;
		}else if(spectre_stat == 1){
			SPECTRE_STROBE_OFF;
			spectre_stat = 2;
		}else if(spectre_stat == 2){
			if( ad_conv_1 != 0){										// ADC1 ϊ
				ADCSRA |= (1 << ADSC);									// A/DϊJn
				spectre_stat = 3;
			}
		}else{
			if( (ADCSRA & (1 << ADIF)) != 0){								// `^cϊ
				ADCSRA |= (1 << ADIF);										// `^cϊtO폜
				if( ad_conv_1 != 0){										// ADC1 ϊ
					spectread_data[spectre_count][spectread_count] = ADCW;
					spectre_count++;
					if(7 < spectre_count){
						spectre_count = 0;
						spectread_count++;
						spectread_count &= (N_of_AD_data - 1);
					}
					ADMUX &= ( (1 << REFS1) | (1 << REFS0) );				// dwrbg͎c
					ADMUX |= ( (0 << MUX2) | (0 << MUX1) | (1 << MUX0) );	// Select ADC6
				}
				spectre_stat = 0;
			}
		}
	}

//	if( (ADCSRA & (1 << ADIF)) != 0){								// `^cϊ
//		ADCSRA |= (1 << ADIF);										// `^cϊtO폜
//		if( ad_conv_1 != 0){										// ADC1 ϊ
//			ad1_data[ad1_count] = ADCW;
//			ad1_count++;
//			ad1_count &= (N_of_AD_data - 1);
//			ADMUX &= ( (1 << REFS1) | (1 << REFS0) );				// dwrbg͎c
//			ADMUX |= ( (0 << MUX2) | (0 << MUX1) | (1 << MUX0) );	// Select ADC6
//		}
//
//		ADCSRA |= (1 << ADSC);										// A/DϊJn
//	}
}
//*****************************************
// AXyNg/D 1 Get A/D data
//  obt@ɓĂf[^𕽋ςĎ擾
// FXyNgԍiPVj
//*****************************************
unsigned short	ad_get_spectredata(unsigned char n)
{
	unsigned char	i;
	unsigned short	sum;

	n &= 0x07;
	sum = 0;
	for(i = 0; i < N_of_AD_data; i++){						// obt@Sđ
		sum += spectread_data[n][i];
	}

	sum /= N_of_AD_data;									// f[^Ŋĕϒlɂ

	return(sum);
}
