//*******************************************************
// 7 spectre display to 8x8-dot-matrix-LED program for ATmega328
// CPU Clock:8MHz
//   iq[Yf[^@UWlgɂj
//
//  file name: disp_8x8_led.c
//      WW}gNXkdcɃ_Ci~bN\(dymanic display 8x8 LED)
//      8x8 LED : OSL641501-BRA (OptoSupply)
//      PD0:8x8 col1               0=Lighting--------------------l
//      PD1:8x8 col2               0=Lighting------------------l l
//      PD2:8x8 col3               0=Lighting----------------l l l
//      PD3:8x8 col4               0=Lighting--------------l l l l
//      PD4:8x8 col5               0=Lighting------------l l l l l
//      PD5:8x8 col6               0=Lighting----------l l l l l l
//      PD6:8x8 col7               0=Lighting--------l l l l l l l
//      PD7:8x8 col8               0=Lighting------l l l l l l l l
//                                                 l l l l l l l l
//                                                 l l l l l l l l
//                                                 l l l l l l l l
//      PB0:8x8 row1               1=Lighting ---- o o o o o o o o
//      PB1:8x8 row2               1=Lighting ---- o o o o o o o o
//      PB2:8x8 row3               1=Lighting ---- o o o o o o o o
//      PC3:8x8 row4               1=Lighting ---- o o o o o o o o 
//      PC4:8x8 row5               1=Lighting ---- o o o o o o o o
//      PC5:8x8 row6               1=Lighting ---- o o o o o o o o
//      PB6:8x8 row7               1=Lighting ---- o o o o o o o o
//      PB7:8x8 row8               1=Lighting ---- o o o o o o o o
//
//
//  2019/02/25 New(TAB4) Taishi
//*******************************************************

#include	<avr/io.h>

#include	"pr_mega328_7spectre.h"
#include	"disp_8x8_led.h"


static	unsigned char	m8x8_enable = 0;							// 0=WW\Ȃ

static	unsigned char	m8x8_one_dot[9] ={0xff,0xfe,0xfd,0xfb,0xf7,0xef,0xdf,0xbf,0x7f};	// hbg\col̒l̂OVɑ\f[^ivZl\f[^lɊZe[uj
static	unsigned char	m8x8_data[9]    ={0xff,0xfe,0xfc,0xf8,0xf0,0xe0,0xc0,0x80,0x00};	// \col̒l̂OVɑ\f[^ivZl\f[^lɊZe[uj
static	unsigned char	m8x8_col[8]     ={0xfe,0xfc,0xf8,0xf0,0xe0,0xc0,0x80,0xff};		// \col dataf[^ĩf[^\j

// *****************************
//  WWp̏ݒ
//  @ Ȃ
//
//  |[g(rbg)ݒ肷
//@@@WW}gNXkdcɃ_Ci~bN\
//@@@PD0:8x8 col1               0=Lighting icsj		
//@@@PD1:8x8 col2               0=Lighting
//@@@PD2:8x8 col3               0=Lighting
//@@@PD3:8x8 col4               0=Lighting
//@@@PD4:8x8 col5               0=Lighting
//@@@PD5:8x8 col6               0=Lighting
//@@@PD6:8x8 col7               0=Lighting
//@@@PD7:8x8 col8               0=Lighting
//@@@PB0:8x8 row1               1=Lighting ij		
//@@@PB1:8x8 row2               1=Lighting
//@@@PB2:8x8 row3               1=Lighting
//@@@PC3:8x8 row4               1=Lighting
//@@@PC4:8x8 row5               1=Lighting
//@@@PC5:8x8 row6               1=Lighting
//@@@PB6:8x8 row7               1=Lighting
//@@@PB7:8x8 row8               1=Lighting
//  2019/02/25 New Taishi
// *****************************
void	init_8x8(void)
{
	DDRB  |= ((1 << DDB0) | (1 << DDB1) | (1 << DDB2) | (1 << DDB6) | (1 << DDB7) );	// WW ij̃rbgo͂ɂ
	PORTB &= ~((1 << PB0) | (1 << PB1)  | (1 << PB2) | (1 << PB6) | (1 << PB7) );		// f[^Fgij
	DDRC  |= ( (1 << DDC3) | (1 << DDC4) | (1 << DDC5) );								// WW ij̃rbgo͂ɂ
	PORTC &= ~((1 << PC3) | (1 << PC4) | (1 << PC5) );									// f[^Fgij
	DDRD  |= ((1 << DDD0) | (1 << DDD1) | (1 << DDD2) | (1 << DDD3) | (1 << DDD4) | (1 << DDD5) | (1 << DDD6) | (1 << DDD7) );	// icsj̃rbgo͂ɂ
	PORTD |= ((1 << PD0) | (1 << PD1) | (1 << PD2) | (1 << PD3) | (1 << PD4) | (1 << PD5) | (1 << PD6) | (1 << PD7) );			// f[^Fkij

	m8x8_enable = 0;						// 0=8x8\Ȃ
}
// *****************************
//  WW\̗L̃Zbg
// *****************************
void	set_8x8_enable(void)
{
	m8x8_enable = 1;				// WW\s
}
// *****************************
//  WW\̖̃Zbg
// *****************************
void	set_8x8_disable(void)
{
	m8x8_enable = 0;				// WW\sȂ
}

// *****************************
//  WWf[^̃Zbg
//  @
//@@@@F\f[^iO`POQRj
//@@@@FwiO`VAOōj
//
// *****************************
void set_8x8_data(unsigned short h, unsigned char n)
{
	h &= 0x3ff;
	h = h/data_of_step;								// OVɂ
	if (8 < h){
		h = 8;
	}
	m8x8_col[n & 0x07] = m8x8_data[h];				// \WWf[^ɓ

}
// *****************************
//  WWf[^̃ZbgiPhbg̕\j
//  @
//@@@@F\f[^iO`POQRj
//@@@@FwiO`VAOōj
//
// *****************************
void set_8x8_one_dot(unsigned short h, unsigned char n)
{
	h &= 0x3ff;
	h = h/data_of_step;								// OVɂ
	if (8 < h){
		h = 8;
	}
	m8x8_col[n & 0x07] = m8x8_one_dot[h];			// \WWf[^ɓ

}
// *****************************
//  WW̕\
//  K莞(200uS -- 1mS)̊荞ݒŌĂ΂镨Ƃ
//@@@PD0:8x8 col1               0=Lighting
//@@@PD1:8x8 col2               0=Lighting
//@@@PD2:8x8 col3               0=Lighting
//@@@PD3:8x8 col4               0=Lighting
//@@@PD4:8x8 col5               0=Lighting
//@@@PD5:8x8 col6               0=Lighting
//@@@PD6:8x8 col7               0=Lighting
//@@@PD7:8x8 col8               0=Lighting
// *****************************
void	disp_8x8(void)
{
	static	unsigned char	keta=0;
	static	unsigned char	row_b[8]={ (1 << PB0), (1 << PB1), (1 << PB2), 0x00,       0x00,       0x00,       (1 << PB6), (1 <<PB7)};	// ɑΉqnvrbgi|j
	static	unsigned char	row_c[8]={ 0x00,       0x00,       0x00,       (1 << PC3), (1 << PC4), (1 << PC5), 0x00,       0x00      };	// ɑΉqnvrbgi|j

	if(m8x8_enable != 0){

		PORTB &= ~((1 << PB0)|(1 << PB1)|(1 << PB2)|(1 << PB6)|(1 <<PB7));	// xi|jSĂneeɂ
		PORTC &= ~((1 << PC3)|(1 << PC4)|(1 << PC5));						// xi|jSĂneeɂ
		PORTD = (m8x8_col[keta]);											// ̏o
		PORTB |= (row_b[keta]);											// i|jnm
		PORTC |= (row_c[keta]);											// i|jnm

		keta++;																// i߂
		keta &= 0x07;
	}
}
