//*****************************************
// 7 spectre display to 8x8-dot-matrix-LED program for ATmega328
// CPU Clock:8MHz
//   iq[Yf[^@UWlgɂj
// File Name:pr_mega328_7spectre.c
//
//
//  2019/02/25 New(TAB4) Taishi
//*****************************************


#include	<avr/interrupt.h>
#include	<avr/io.h>
#include	<avr/pgmspace.h>
#include	<avr/sleep.h>
#include	<avr/eeprom.h>
#include	<stdio.h>

#include	"pr_mega328_7spectre.h"
#include	"timer.h"
#include	"disp_8x8_led.h"
#include	"port_bit.h"
#include	"ad_conv.h"
#include	"utl.h"


static	unsigned short	hold_level;							// xI[o[z[h̎̃z[hl
static	unsigned short	spectre_d[8];						// s[Nz[ḧꎞIɂ߂鏊

// **********************************************************
// ********************** Soft Timer ************************
// **********************************************************

volatile unsigned int	wait_i;
volatile unsigned int	wait_j;
volatile unsigned char	wait_us;
// ************************************
// Delay 2uS
// t: uS (max 255)
// CPU Clock:8.000MHz
//  while ߂ for ŎԂ킹Ă
// ************************************
void delay_2us(unsigned char t)
{
	unsigned char	i;

	for(i=0;i<t;i++){
		wait_us++;				// 1uS Delay??
		wait_us++;				// 1uS Delay??
		wait_us++;				// 1uS Delay??
	}
}
//***************************
// Wait
//  tm : Wait Time(ms) max. 8000
// CPU Clock:8.000MHz
//***************************
void	delay_ms(int tm)
{

	for(wait_i = 0; wait_i < tm; wait_i++){
		delay_2us(500/2);
		delay_2us(500/2);
	}
}
//***************************
// z[h[h̃Zbg
//   xz[h̎́@z[hl߂Bhold_levelɓ
//
//  old_hold_modeF܂ł̃z[h[h
//                     0:XCb`ZŃz[hA1:xI[o[z[hA2:s[Nz[h
// ߂l@VɌ߂z[h[h
//                     0:XCb`ZŃz[hA1:xI[o[z[hA2:s[Nz[h
//***************************
unsigned char	hold_mode_set(unsigned char old_hold_mode)
{
	unsigned char	zz = 0;
	unsigned char	nd;
	char			uc;

	nd = old_hold_mode;
	set_8x8_data(data_of_step, 0);						// WWf[^(63Hz)\P
	set_8x8_data(0, 1);									// WWf[^(160Hz)\NA
	set_8x8_data(0, 2);									// WWf[^(400Hz)\NA
	set_8x8_data(0, 3);									// WWf[^(1000Hz)\NA
	set_8x8_data(0, 4);									// WWf[^(2500Hz)\NA
	set_8x8_data(0, 5);									// WWf[^(6300Hz)\NA
	set_8x8_data(0, 6);									// WWf[^(16000Hz)\NA
	set_8x8_data(0, 7);									// WWf[^(sum)\NA
	if(nd == 1){										// 1:xI[o[z[h̎
		set_8x8_one_dot(hold_level, 7);					//  WWf[^̃Zbg
	}else if(nd == 2){									// 2:s[Nz[h̎
		set_8x8_data(1023, 7);							//  WWf[^̃Zbg
	}

	while(1){
		uc = get_action_sw();									// XCb`Ԃ
		uc = uc & SWR_MASK;										// XCb`ɂ
		if(uc == SWR_OFF_SHORT){								// XCb`ꂽBiĂԂ͒Zj
			if(nd == 0){										// 0:XCb`ZŃz[h̎
				nd = 1;											// 1:xI[o[z[hɂ
				set_8x8_one_dot(hold_level, 7);					//  WWf[^̃Zbg
			}else if(nd == 1){									// 1:xI[o[z[h̎
				nd = 2;											// 2:s[Nz[hɂ
				set_8x8_data(1023, 7);							//  WWf[^̃Zbg
			}else{
				nd = 0;											// 0:XCb`ZŃz[hɂ
				set_8x8_data(0, 7);								// WWf[^(sum)\NA
			}
		}else if(uc == SWR_OFF_LONG){							// XCb`ꂽBiĂԂ͒j
			break;
		}
	}

	if(nd == 1){												// x̃[h 1:xI[o[z[h̎
		// z[hx̃Zbg
		set_8x8_data(data_of_step * 2, 1);						// WWf[^(160Hz)\Q
		while(1){
			uc = get_action_sw();								// XCb`Ԃ
			uc = uc & SWR_MASK;									// XCb`ɂ
			if(uc == SWR_OFF_SHORT){							// XCb`ꂽBiĂԂ͒Zj
				hold_level += data_of_step;
				if (1023 < hold_level){
					hold_level = data_of_step;
				}
				set_8x8_one_dot(hold_level, 7);					//  WWf[^̃Zbg
			}else if(uc == SWR_OFF_LONG){						// XCb`ꂽBiĂԂ͒j
				break;
			}
		}
	}

	set_8x8_data(zz, 0);									// WWf[^(63Hz)\NA
	set_8x8_data(zz, 1);									// WWf[^(160Hz)\NA
	set_8x8_data(zz, 2);									// WWf[^(400Hz)\NA
	set_8x8_data(zz, 3);									// WWf[^(1000Hz)\NA
	set_8x8_data(zz, 4);									// WWf[^(2500Hz)\NA
	set_8x8_data(zz, 5);									// WWf[^(6300Hz)\NA
	set_8x8_data(zz, 6);									// WWf[^(16000Hz)\NA
	set_8x8_data(zz, 7);									// WWf[^(sum)\NA

	return(nd);
}
//***************************
//  Main
//***************************
int	main(void)
{

	char			uc;
	unsigned char	hold;
	unsigned char	hold_mode;							// 0:XCb`ZŃz[hA1:xI[o[z[hA2:s[Nz[h
	unsigned char	spectre_no;
	unsigned short	spectre_data;
	unsigned short	spectre_sum;
	unsigned short	sum_max;							// s[Nz[hp̍ől

	init_8x8();											//  WWp̏ݒ
	set_8x8_enable();									//  WW\̗L̃Zbg

	sw_init();											//@XCb`̏ݒ
	spectread_init();									// A/D 1 Initial

	timer2_init();										// Timer2 Initial

	tim_10ms_led = 1;									// kdcpPOrPʃ^C}[
	spectre_no = 0;
	hold = 0;
	hold_mode = 0;
	spectre_sum = 0;
	sum_max = 0;										// őlNA
	hold_level = 1000;									// xI[o[z[h̎̃z[hl

	sei();												// 荞݉

	while(1){
	// XCb`
		uc = get_action_sw();									// XCb`Ԃ
		uc = uc & SWR_MASK;										// XCb`ɂ
		if(uc == SWR_OFF_SHORT){								// XCb`ꂽBiĂԂ͒Zj
			if(hold_mode == 0){									// XCb`ł̃z[h[h̎
				if(hold != 0){									// z[h̎
					hold = 0;									// z[h߂
					sum_max = 0;								// őlNA
		 			spectre_no = 0;
 					tim_10ms_led = 20;							// QOOrݒ@\n߂܂ł͏҂
				}else{											// z[hłȂ
					hold = 1;									// z[h
				}
			}else if(hold_mode == 1){							// x̃z[h[h̎
				hold = 0;										// z[h߂
			}else if(hold_mode == 2){							// s[Nz[h̎
				hold = 0;										// z[h߂
				sum_max = 0;									// őlNA
	 			spectre_no = 0;
 				tim_10ms_led = 20;								// QOOrݒ@\n߂܂ł͏҂
			}
		}else if(uc == SWR_OFF_LONG){							// XCb`ꂽBiĂԂ͒j
			hold_mode = hold_mode_set(hold_mode);				// z[h[h̃Zbg
			hold = 0;											// z[h߂
			sum_max = 0;										// őlNA
 			spectre_no = 0;
 			tim_10ms_led = 20;									// QOOrݒ@\n߂܂ł͏҂
		}


	// WW\
 		if(tim_10ms_led == 0){										// POro߂
 			tim_10ms_led = 1;										// POrݒ
			if((hold_mode == 0)||(hold_mode == 1)){					// XCb`z[h@xz[h̎
				if(hold == 0){										// z[hŖ
	 				spectre_data = ad_get_spectredata(spectre_no+1);	// A/D1iXyNgj 擾
 					spectre_sum += spectre_data;
 					if(1023 < spectre_data){
 						spectre_data = 1023;
 					}
 					set_8x8_data(spectre_data, spectre_no);				//  WWf[^̃Zbg
 					spectre_no++;
 					if(7 <= spectre_no){
 						spectre_no = 0;
 						spectre_sum /= 10;
						if(hold_mode == 1){								// xz[h̎
		 					if(1023 < spectre_sum){
 								spectre_sum = 1023;
 							}
	 						set_8x8_data(spectre_sum, 7);				//  WԖڂ̂WWf[^ɍv\
							if(hold_level <= spectre_sum){
								hold = 1;								// z[h
							}
							spectre_sum = 0;							// vNA
						}else{
		 					if(1023 < spectre_sum){
 								spectre_sum = 1023;
 							}
	 						set_8x8_data(spectre_sum, 7);				//  WԖڂ̂WWf[^ɍv\
							spectre_sum = 0;							// vNA
						}
 					}
 				}
			}else{													// s[Nz[h̎
	 			spectre_data = ad_get_spectredata(spectre_no+1);	// A/D1iXyNgj 擾
 				spectre_sum += spectre_data;
 				if(1023 < spectre_data){
 					spectre_data = 1023;
 				}
 				spectre_d[spectre_no] = spectre_data;;				//  WWf[^̈ꎞ߂
 				spectre_no++;
 				if(7 <= spectre_no){
 					spectre_no = 0;
					spectre_sum /= 10;
					if(sum_max < spectre_sum){						// ܂ł̍ől@傫
		 				if(1023 < spectre_sum){
 							spectre_sum = 1023;
 						}
	 					set_8x8_data(spectre_d[0], 0);				//  PԖڂ̂WWf[^\
	 					set_8x8_data(spectre_d[1], 1);				//  QԖڂ̂WWf[^\
	 					set_8x8_data(spectre_d[2], 2);				//  RԖڂ̂WWf[^\
	 					set_8x8_data(spectre_d[3], 3);				//  SԖڂ̂WWf[^\
	 					set_8x8_data(spectre_d[4], 4);				//  TԖڂ̂WWf[^\
	 					set_8x8_data(spectre_d[5], 5);				//  UԖڂ̂WWf[^\
	 					set_8x8_data(spectre_d[6], 6);				//  VԖڂ̂WWf[^\
	 					set_8x8_data(spectre_sum, 7);				//  WԖڂ̂WWf[^ɍv\
						sum_max = spectre_sum;						// őlXV
 					}else{											// 傫Ȃ
						;											// Ȃ
					}
					spectre_sum = 0;								// vNA
				}
			}
		}

	}
}
