//*****************************************
// 7 spectre display to 8x8-dot-matrix-LED program for ATmega328
// CPU Clock:8MHz
//   iq[Yf[^@UWlgɂj
//
// File Name:timer.c
//
//  2019/02/25 New(TAB4) Taishi
//*****************************************
#include	<avr/interrupt.h>
#include	<avr/io.h>


#include	"pr_mega328_7spectre.h"
#include	"disp_8x8_led.h"
#include	"ad_conv.h"
#include	"timer.h"


unsigned char	tim_500us;						// 10mSPʂJE^[
unsigned char	tim_10ms;						// PbPʂJE^[
unsigned char	tim_10ms_led;					// kdcpPOrPʃ^C}[
unsigned char	tim_10ms_sw;					// rvhsbgpPOrPʃ^C}[
unsigned char	tim_10ms_swr_length;			// rvhsbgpԂPOrPʃ^C}[@|P
unsigned char	tim_10ms_swr_continue;			// rvhsbgpAPOrPʃ^C}[@|P
unsigned char	tim_10ms_sblink;				// \_ŗpPOrPʃ^C}[@|P
unsigned char	tim_1s_no_key_timeup;			// L[͂Ȃ̃^CAbvp
unsigned char	count_1s_disp;					// t[̂PbJE^[



// **********************************************************
// ************************ Timer 2 *************************
// **********************************************************
// 8MHz-- 1mS Interrupt
//#define	COUNT_1MS		125										// 1mS (8uS x 125 = 1mS)
//#define	D_TCCR2B	((1 << CS22) | (0 << CS21) | (0 << CS20))	// Timer Start (8MHz/64= 125kHz, 8uS)

// 8MHz-- 500S Interrupt
#define	COUNT_1MS		250										// 500uS  (4uS x 250 = 1000uS)
#define	COUNT_500uS		125										// 500uS  (4uS x 125 = 500uS)
#define	D_TCCR2B	((0 << CS22) | (1 << CS21) | (1 << CS20))	// Timer Start (8MHz/32= 250kHz, 4uS)

//*****************************************
// Timer2 Initial
//  500uS 荞݂ɐݒ肷
//*****************************************
void	timer2_init(void)
{
	TCCR2B = 0;											// Timer Stop
	TCNT2 = 0;											// Timer2 Count Set to ZERO
	TCCR2A = ((1 << WGM21) | (0 << WGM20));				// A Comper Match, Dont Output Timer2 Signal
	OCR2A  = COUNT_500uS;								// 500uS
	TCCR2B = D_TCCR2B;									// Timer Start
	TIMSK2 |= (1 << OCIE2A);							// A Comper Match Interrupt Enable

	tim_500us = 20;										// 10mSPʂJE^[
	tim_10ms = 0;										// PbPʂJE^[
	tim_10ms_led = 0;									// kdcpPOrPʃ^C}[
	tim_10ms_sw = 0;									// rvhsbgpPOrPʃ^C}[
	tim_10ms_swr_length = 0;							// rvhsbgpԂPOrPʃ^C}[@|P
	tim_10ms_swr_continue = 0;							// rvhsbgpAPOrPʃ^C}[@|P
	tim_10ms_sblink = 0;								// \_ŗpPOrPʃ^C}[@|P
	count_1s_disp = 0;									// t[̂PbJE^[
}
//*****************************************
// Timer2 Close
//  Timer2 ̎gp߂
//*****************************************
void	timer2_close(void)
{
	TCCR2B = 0;											// Timer Stop
	TCNT2 = 0;											// Timer2 Count Set to ZERO
	TCCR2A = 0;											// Dont Output Timer2 Signal
	TIMSK2 = 0;											// Interrupt Disable

}
//***************************
// Timer2 Comper Match A Interrupt
//
//  500uS 
//***************************
ISR	(TIMER2_COMPA_vect)	
{
	tim_500us--;								// 10mSPʂJE^[
	if(tim_500us == 0){							// 10mSo߂
		tim_500us = 20;							// 10mSPʂJE^[
		tim_10ms++;
		if(100 <= tim_10ms){					// Pbo
			tim_10ms = 0;
			count_1s_disp++;					// t[̂PbJE^[
		}

		if(tim_10ms_led != 0){
			tim_10ms_led--;						// kdcpPOrPʃ^C}[@|P
		}

		if(tim_10ms_sw != 0){
			tim_10ms_sw--;						// rvhsbgpPOrPʃ^C}[@|P
		}

		if(tim_10ms_swr_continue != 0){
			tim_10ms_swr_continue--;			// rvhsbgpAPOrPʃ^C}[@|P
		}

		if(tim_10ms_swr_length != 0){
			tim_10ms_swr_length--;				// rvhsbgpԂPOrPʃ^C}[@|P
		}

		if(tim_10ms_sblink != 0){
			tim_10ms_sblink--;					// \_ŗpPOrPʃ^C}[@|P
		}

	}

	ad_set_spectre_data();						// A/D1(specter) set A/D data to spectre data buffer

	disp_8x8();									// 8x8̕\
}

//***************************
// ԃL[͂̔f
//@ on:1 = L[LA@0= ^CAbṽ`FbN
//  ߂l@O@^CAbvĂȂ
//@@O@^CAbv
//***************************
unsigned char	proc_no_key_timeup(unsigned char on)
{
	unsigned char	r=0;

	if (on == 1){
		tim_1s_no_key_timeup = TIM_DISP_RETURN;		// ^CAbv̎Ԑݒ
	}else{
		if(tim_1s_no_key_timeup == 0){				// ^CAbv
			r = 0xff;
		}
	}
	return(r);
}
