//*****************************************
// 7 spectre display to 8x8-dot-matrix-LED program for ATmega328
// CPU Clock:8MHz
//   iq[Yf[^@UWlgɂj
//
// File Name:utl.c
//
//  2019/02/25 New(TAB4) Taishi
//*****************************************

#include	"pr_mega328_7spectre.h"
#include	"utl.h"

// **********************************************************
// ************************ Utility *************************
// **********************************************************

#if	0
/****************************************************************/
/* PoCgf[^										*/
/* PUîQ̂`rbhhɕϊ							*/
/* ʌ̂OTvX͂Ȃ									*/
/****************************************************************/
void	wtod_02x(char *bf,unsigned char ucd)
{
	*bf = (char)(((ucd>>4) & 0x0f)|'0');
	if (*bf > '9'){
		*bf += 7;
	}
	bf++;
	*bf = (char)(((ucd) & 0x0f)|'0');
	if (*bf > '9'){
		*bf += 7;
	}
	bf++;
	*bf=0;
}
#endif

#if	0
/****************************************/
/* PoCgf[^				*/
/* Q̂POî`rbhhɕϊ	*/
/* ʌ̂OTvX͂Ȃ			*/
/****************************************/
void	wtod_02u(char *bf,unsigned char ucd)
{
	*bf = (char)('0'+(ucd/10));
	bf++;
	*bf = (char)('0'+(ucd%10));
	bf++;
	*bf=0;
}
#endif

#if	0
/****************************************/
/* PoCgf[^				*/
/* Q̂POî`rbhhɕϊ	*/
/* ʌ̂OTvX				*/
/****************************************/
void	wtod_2u(char *bf,unsigned char ucd)
{
	*bf = (char)('0'+(ucd/10));
	if(*bf == '0'){
		*bf = ' ';
	}
	bf++;
	*bf = (char)('0'+(ucd%10));
	bf++;
	*bf=0;
}
#endif

/****************************************/
/* QoCgf[^				*/
/* Ŝabcɕϊ				*/
/****************************************/
void	wtod_04bcd(unsigned char *bf,unsigned short usd)
{
	unsigned char	i;
	unsigned short	cui;

	if(9999 < usd){
		usd = 9999;
	}
	cui = 1000;
	for(i=0;i<4;i++){
		*bf = (unsigned char)(usd/cui);
		usd %= cui;
		bf++;
		cui /= 10;
	}
}
/****************************************/
/* QoCgf[^				*/
/* ŜPOî`rbhhɕϊ	*/
/* ʌ̂OTvX͂Ȃ			*/
/****************************************/
void	wtod_04u(char *bf,unsigned int usd)
{
	int				i;
	unsigned int	cui;

	if(9999 < usd){
		usd = 9999;
	}
	cui = 1000;
	for(i=0;i<4;i++){
		*bf = (char)('0'+(usd/cui));
		usd %= cui;
		bf++;
		cui /= 10;
	}
	*bf=0;
}
/****************************************/
/* QoCgf[^				*/
/* ŜPOî`rbhhɕϊ	*/
/* ʌ̂OTvX				*/
/****************************************/
void	wtod_4u(char *bf,unsigned int usd)
{
	int				i;
	char			*bfb;

	bfb = bf;
	wtod_04u(bf, usd);					// QoCgf[^ŜPOî`rbhhɕϊ(ʌ̂OTvX͂Ȃ)
	for(i=0;i<3;i++,bfb++){
		if(*bfb == '0'){
			*bfb = ' ';
		}else{
			break;
		}
	}
}

#if	0
/****************************************/
/* QoCgf[^				*/
/* T̂POî`rbhhɕϊ	*/
/* ʌ̂OTvX͂Ȃ			*/
/****************************************/
void	wtod_05u(char *bf,unsigned int usd)
{
	int				i;
	unsigned int	cui;

	cui = 10000;
	for(i=0;i<5;i++){
		*bf = (char)('0'+(usd/cui));
		usd %= cui;
		bf++;
		cui /= 10;
	}
	*bf=0;
}
#endif

#if	0
/****************************************/
/* QoCgf[^				*/
/* T̂POî`rbhhɕϊ	*/
/* ʌ̂OTvX				*/
/****************************************/
void	wtod_5u(char *bf,unsigned int usd)
{
	int				i;
	char			*bfb;

	bfb = bf;
	wtod_05u(bf, usd);					// QoCgf[^T̂POî`rbhhɕϊ(ʌ̂OTvX͂Ȃ)
	for(i=0;i<4;i++,bfb++){
		if(*bfb == '0'){
			*bfb = ' ';
		}else{
			break;
		}
	}
}
#endif

#if	0
//*****************************************
// (unsigned int)
// uc0: mDO̒l
// uc1: mDP̒l
// uc2: mDQ̒l
// def: SĈĂ Cl
//*****************************************
unsigned int	tasuuketu_ui(unsigned int ui0, unsigned int ui1, unsigned int ui2, unsigned int def)
{
	unsigned int	ui;

	if(ui0 == ui1){
		ui = ui0;
	}else if(ui0 == ui2){
		ui = ui0;
	}else if(ui1 == ui2){
		ui = ui1;
	}else{
		ui = def;
	}

	return(ui);
}
#endif

#if	0
//*****************************************
// (unsigned char)
// uc0: mDO̒l
// uc1: mDP̒l
// uc2: mDQ̒l
// def: SĈĂ Cl
//*****************************************
unsigned char	tasuuketu_uc(unsigned char uc0, unsigned char uc1, unsigned char uc2, unsigned char def)
{
	unsigned char	uc;

	if(uc0 == uc1){
		uc = uc0;
	}else if(uc0 == uc2){
		uc = uc0;
	}else if(uc1 == uc2){
		uc = uc1;
	}else{
		uc = def;
	}

	return(uc);
}
#endif
